// @type component
// @name three-d-carousel
var slider = document.querySelector('.slider');
var slide = document.querySelectorAll('.slide');
var x = 0;
var down;
var factor = 8.5;
window.pointer = {
  delta: 0
};
slide[0].style.transform = '' + 'translatex(' + (-200 / factor) + 'vmin)' + 'scale(' + 0.8 + ')' + '';
slide[1].style.transform = '' + 'translatex(' + (200 / factor) + 'vmin)' + 'scale(' + 0.8 + ')' + '';

function mouseEnd() {
  slider.style.cursor = '';
  slider.style.cursor = '';
  down = false;
  slide[0].style.transition = 'transform 0.2s';
  slide[1].style.transition = 'transform 0.2s';
  slide[2].style.transition = 'transform 0.2s';
  var snap = slider.clientWidth / 4;
  if (window.pointer.delta > snap) {
    slide[2].style.transform = '' + 'translatex(' + (-200 / factor) + 'vmin)' + 'scale(' + 0.8 + ')' + '';
    slide[0].style.transform = '' + 'translatex(' + (200 / factor) + 'vmin)' + 'scale(' + 0.8 + ')' + '';
    slide[1].style.transform = '' + 'translatex(0)' + 'scale(1)' + '';
    slide = [slide[2], slide[0], slide[1]];
  } else if (window.pointer.delta < snap * -1) {
    slide[1].style.transform = '' + 'translatex(' + (-200 / factor) + 'vmin)' + 'scale(' + 0.8 + ')' + '';
    slide[2].style.transform = '' + 'translatex(' + (200 / factor) + 'vmin)' + 'scale(' + 0.8 + ')' + '';
    slide[0].style.transform = '' + 'translatex(0)' + 'scale(1)' + '';
    slide = [slide[1], slide[2], slide[0]];
  } else {
    slide[0].style.transform = '' + 'translatex(' + (-200 / factor) + 'vmin)' + 'scale(' + 0.8 + ')' + '';
    slide[1].style.transform = '' + 'translatex(' + (200 / factor) + 'vmin)' + 'scale(' + 0.8 + ')' + '';
    slide[2].style.transform = '' + 'translatex(0)' + 'scale(1)' + '';
  }
}

function mouseMove(e) {
  if (!down) return false;
  e.preventDefault();
  slider.style.cursor = '-webkit-grabbing';
  slider.style.cursor = '-moz-grabbing';
  var pX = e.pageX || e.touches[0].pageX;
  //window.pointer.delta = Math.max(0,x - pX);
  window.pointer.delta = x - pX;
  var dX = window.pointer.delta;
  var transX, transX2, transX3, scale, scale2, scale3;
  if (dX < 0) {
    transX = Math.min(200, dX * -0.5) / factor + 'vmin';
    transX3 = Math.max(-200, 200 + dX) / factor + 'vmin';
    transX2 = Math.min(0, -200 - dX * 0.5) / factor + 'vmin';
    scale = Math.max(0.8, 1 - Math.abs(dX * 1 / 2000));
    scale3 = 0.8;
    scale2 = Math.min(0.8 + (1 - scale));
    slide[0].style.zIndex = 3;
    slide[1].style.zIndex = 1;
    slide[2].style.zIndex = 2;
  } else {
    transX = Math.max(-200, dX * -0.5) / factor + 'vmin';
    transX2 = Math.min(200, -200 + dX) / factor + 'vmin';
    transX3 = Math.max(0, 200 - dX * 0.5) / factor + 'vmin';
    scale = Math.max(0.8, 1 - Math.abs(dX * 1 / 2000));
    scale2 = 0.8;
    scale3 = Math.min(0.8 + (1 - scale));
    slide[0].style.zIndex = 1;
    slide[1].style.zIndex = 3;
    slide[2].style.zIndex = 2;
  }
  slide[2].style.transform = '' + 'translatex(' + transX + ')' + 'scale(' + scale + ')' + '';
  slide[0].style.transform = '' + 'translatex(' + transX2 + ')' + 'scale(' + scale2 + ')' + '';
  slide[1].style.transform = '' + 'translatex(' + transX3 + ')' + 'scale(' + scale3 + ')' + '';
}

function mouseStart(e) {
  down = true;
  x = e.pageX || e.touches[0].pageX;
  slide[0].style.transition = '';
  slide[1].style.transition = '';
  slide[2].style.transition = '';
}
slider.addEventListener('mousedown', mouseStart);
slider.addEventListener('touchstart', mouseStart);
slider.addEventListener('mouseup', mouseEnd);
slider.addEventListener('touchend', mouseEnd);
slider.addEventListener('mousemove', mouseMove);
slider.addEventListener('touchmove', mouseMove);